<?php
namespace Planejamento\Entities;

use Geral\Util\DateUtil;
use Setforms2\Shared\Registry;

class Paramplaneja extends Base\Paramplaneja
{
    /**
     * Identificador de permissao para lancar os efetivos sem retirada do planejamento.
     */
    const IDPERLEFESRETPLA_SIM = "S";
    /**
     * Identificador de permissao para lancar os efetivos sem retirada do planejamento.
     */
    const IDPERLEFESRETPLA_NAO = "N";

    /**
     * Identificador de permissao para lancar efetivos com data superior a data de processamento.
     */
    const IDPEREFEPOSDTPR_SIM = "S";
    /**
     * Identificador de permissao para lancar efetivos com data superior a data de processamento.
     */
    const IDPEREFEPOSDTPR_NAO = "N";

    /**
     * Identifica se bloqueia alteração de efetivos para dias fechados.
     */
    const IDBLQEFEDIAFECH_SIM = "S";
    /**
     * Identifica se bloqueia alteração de efetivos para dias fechados.
     */
    const IDBLQEFEDIAFECH_NAO = "N";


    private $idcoletapesquisa = 'IMPORTACAO';



    public function retornaParamplaneja($nrorg, $cdfilial) {
        $obj = self::getObjectByWhere(
            'NRORG = ? AND CDFILIAL = ?',
            array(
                $nrorg,
                $cdfilial,
            )
        );

        return $obj;
    }

    public function incluiParamplaneja ($nrorg, $cdfilial, $id_coleta_pesquisa) {
        try {
            $obj = new self();
            $obj->setCdparplaneja(1);
            $obj->setNrorg($nrorg);
            $obj->setCdfilial($cdfilial);
            $obj->setIdcoletapesquisa($id_coleta_pesquisa);
            $obj->setIdprinvenreti('N');
            $obj->setIdretiautobcome(1);
            $obj->setIdutreqcompentd('N');
            $obj->setIdservincfilagr('N');
            $obj->setIdperlefesretpla('N');
            $obj->setIdblqefediafech('N');
            $obj->setIdperefeposdtpr('N');
            $obj->setDtinclusao(DateUtil::getDataAtual());
            $obj->setNrorginclusao($nrorg);
            $obj->setNrorgultatu($nrorg);
            $obj->setIdativo('S');
            $obj->persist();

            Registry::getEntityManager()->flush();

        } catch (\Exception $e) {
            tk_warning('Erro '.$e->getMessage());
        }
    }

    public function getIdcoletapesquisa()
    {
        return $this->idcoletapesquisa;
    }

    public function setIdcoletapesquisa($idcoletapesquisa)
    {
        $this->idcoletapesquisa = $idcoletapesquisa;
        return $this;
    }

    public function updateSetores($nrorg ,$cdsetorfixo, $cdsetorpercapita,  $data, $cdoperinclusao)
    {
        $this->setCdsetconfixo($cdsetorfixo);
        $this->setCdsetconperc($cdsetorpercapita);
        $this->setDtultatu($data);
        $this->setCdoperultatu($cdoperinclusao);
        $this->setNrorgultatu($nrorg);

        $this->persist();

    }


}